//  $Id: TclButton.hh 1.1 Fri, 18 Jul 1997 15:57:04 -0700 wlee $
// 
//  Copyright (c) 1994 by the University of Southern California
//  and/or the International Business Machines Corporation.
//  All rights reserved.
//
//  Permission to use, copy, modify, and distribute this software and
//  its documentation in source and binary forms for lawful
//  non-commercial purposes and without fee is hereby granted, provided
//  that the above copyright notice appear in all copies and that both
//  the copyright notice and this permission notice appear in supporting
//  documentation, and that any documentation, advertising materials,
//  and other materials related to such distribution and use acknowledge
//  that the software was developed by the University of Southern
//  California, Information Sciences Institute and/or the International
//  Business Machines Corporation.  The name of the USC or IBM may not
//  be used to endorse or promote products derived from this software
//  without specific prior written permission.
//
//  NEITHER THE UNIVERSITY OF SOUTHERN CALIFORNIA NOR INTERNATIONAL
//  BUSINESS MACHINES CORPORATION MAKES ANY REPRESENTATIONS ABOUT
//  THE SUITABILITY OF THIS SOFTWARE FOR ANY PURPOSE.  THIS SOFTWARE IS
//  PROVIDED "AS IS" AND WITHOUT ANY EXPRESS OR IMPLIED WARRANTIES,
//  INCLUDING, WITHOUT LIMITATION, THE IMPLIED WARRANTIES OF
//  MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE, TITLE, AND 
//  NON-INFRINGEMENT.
//
//  IN NO EVENT SHALL USC, IBM, OR ANY OTHER CONTRIBUTOR BE LIABLE FOR ANY
//  SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES, WHETHER IN CONTRACT,
//  TORT, OR OTHER FORM OF ACTION, ARISING OUT OF OR IN CONNECTION WITH,
//  THE USE OR PERFORMANCE OF THIS SOFTWARE.
//
//  Questions concerning this software should be directed to 
//  info-ra@isi.edu.
//
//  Author(s): WeeSan Lee (wlee@isi.edu)


#ifndef TCLBUTTON_HH
#define TCLBUTTON_HH

#include "TclObj.hh"

class TclButton : public TclObject
{
   private:
      char *pzcLabel;

   public:
      TclButton(char *pzcName) : TclObject(pzcName), pzcLabel(0) {}
      TclButton(char *pzcName, char *pzcLabel) : 
	 TclObject(pzcName), pzcLabel(pzcLabel) {}
      TclButton(char *pzcName, void *pvExtraArgument) 
	 : TclObject(pzcName, pvExtraArgument) {}
      virtual int setExtraArgument(void *pvExtraArgument)
         {
	 // Setup extra argument first
	 TclObject::setExtraArgument(pvExtraArgument);
	 return label(pzcLabel);
	 }
      int label(char *pzcLabel);
      int enable(void);
      int disable(void);
};

#endif // TCLBUTTON_HH
