// $Id: CommunityMap.hh 1.3 Fri, 18 Jul 1997 15:53:23 -0700 wlee $
// 
//  Copyright (c) 1994 by the University of Southern California
//  and/or the International Business Machines Corporation.
//  All rights reserved.
//
//  Permission to use, copy, modify, and distribute this software and
//  its documentation in source and binary forms for lawful
//  non-commercial purposes and without fee is hereby granted, provided
//  that the above copyright notice appear in all copies and that both
//  the copyright notice and this permission notice appear in supporting
//  documentation, and that any documentation, advertising materials,
//  and other materials related to such distribution and use acknowledge
//  that the software was developed by the University of Southern
//  California, Information Sciences Institute and/or the International
//  Business Machines Corporation.  The name of the USC or IBM may not
//  be used to endorse or promote products derived from this software
//  without specific prior written permission.
//
//  NEITHER THE UNIVERSITY OF SOUTHERN CALIFORNIA NOR INTERNATIONAL
//  BUSINESS MACHINES CORPORATION MAKES ANY REPRESENTATIONS ABOUT
//  THE SUITABILITY OF THIS SOFTWARE FOR ANY PURPOSE.  THIS SOFTWARE IS
//  PROVIDED "AS IS" AND WITHOUT ANY EXPRESS OR IMPLIED WARRANTIES,
//  INCLUDING, WITHOUT LIMITATION, THE IMPLIED WARRANTIES OF
//  MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE, TITLE, AND 
//  NON-INFRINGEMENT.
//
//  IN NO EVENT SHALL USC, IBM, OR ANY OTHER CONTRIBUTOR BE LIABLE FOR ANY
//  SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES, WHETHER IN CONTRACT,
//  TORT, OR OTHER FORM OF ACTION, ARISING OUT OF OR IN CONNECTION WITH,
//  THE USE OR PERFORMANCE OF THIS SOFTWARE.
//
//  Questions concerning this software should be directed to 
//  info-ra@isi.edu.
//
//  Author(s): Cengiz Alaettinoglu (cengiz@isi.edu)

#ifndef _STNAMECommunityMAP_H
#define _STNAMECommunityMAP_H

#include "config.hh"
#include "Map.hh"

class CommunityMap : public Map {
  public:
   CommunityMap(SymTab& dflt) : Map(dflt) {}

   Pix add_entry(char *cname) {
      Pix r, s;

      if (r = seek(cname))
	 return r;

      char *dup_cname = (char *) STAllocator.allocate(strlen(cname)+1);
      strcpy(dup_cname, cname);
      (void) (*this)[dup_cname];
      r = seek(dup_cname);

      dup_cname = (char *) STAllocator.allocate(strlen(cname)+5);
      strcpy(dup_cname, "NOT ");
      strcpy(dup_cname + 4, cname);

      (void) (*this)[dup_cname];
      s = seek(dup_cname);

      contents(r).not = s;
      contents(s).not = r;
      contents(s).evaluated = 2;

      return r;
   }

   void dump();
   _SetOfPix& expand(Pix p);
};

extern CommunityMap Community_map;
extern void Comm2AdrPrfx( _SetOfPix&, _SetOfPix& );
extern void Comm2AdrPrfx(Pix p, _SetOfPix &PRFXset );

#endif
