// $Id: PrefaskMap.hh 1.4 Fri, 18 Jul 1997 16:00:26 -0700 wlee $
// 
//  Copyright (c) 1994 by the University of Southern California
//  and/or the International Business Machines Corporation.
//  All rights reserved.
//
//  Permission to use, copy, modify, and distribute this software and
//  its documentation in source and binary forms for lawful
//  non-commercial purposes and without fee is hereby granted, provided
//  that the above copyright notice appear in all copies and that both
//  the copyright notice and this permission notice appear in supporting
//  documentation, and that any documentation, advertising materials,
//  and other materials related to such distribution and use acknowledge
//  that the software was developed by the University of Southern
//  California, Information Sciences Institute and/or the International
//  Business Machines Corporation.  The name of the USC or IBM may not
//  be used to endorse or promote products derived from this software
//  without specific prior written permission.
//
//  NEITHER THE UNIVERSITY OF SOUTHERN CALIFORNIA NOR INTERNATIONAL
//  BUSINESS MACHINES CORPORATION MAKES ANY REPRESENTATIONS ABOUT
//  THE SUITABILITY OF THIS SOFTWARE FOR ANY PURPOSE.  THIS SOFTWARE IS
//  PROVIDED "AS IS" AND WITHOUT ANY EXPRESS OR IMPLIED WARRANTIES,
//  INCLUDING, WITHOUT LIMITATION, THE IMPLIED WARRANTIES OF
//  MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE, TITLE, AND 
//  NON-INFRINGEMENT.
//
//  IN NO EVENT SHALL USC, IBM, OR ANY OTHER CONTRIBUTOR BE LIABLE FOR ANY
//  SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES, WHETHER IN CONTRACT,
//  TORT, OR OTHER FORM OF ACTION, ARISING OUT OF OR IN CONNECTION WITH,
//  THE USE OR PERFORMANCE OF THIS SOFTWARE.
//
//  Questions concerning this software should be directed to 
//  info-ra@isi.edu.
//
//  Author(s): Cengiz Alaettinoglu <cengiz@isi.edu>

#ifndef PrefaskMap_H
#define PrefaskMap_H

#include "config.hh"
#include "Prefask.AVLSet.h"
#include "Allocator.hh"
#include "net.hh"

extern Allocator STAllocator;

class PrefaskMap : private PrefaskAVLSet {
public:
   Pix add_entry(char *prefask) {
      Pix p;
      Prefask prfx(prefask);
      return (p = seek(prfx)) ? p : add(prfx);
   }

   Pix add_entry(ipAddr &ipaddr) {
      return add_entry(ipaddr.getIpaddrMask());
   }

   Pix add_entry_already_allocated(char *prefask) {
      return add_entry(prefask);
   }

   void dump();

   Prefask &operator()(Pix p) {
      return PrefaskAVLSet::operator()(p);
   }

   void clear() {
     PrefaskAVLSet::clear();
   }

};

extern PrefaskMap Prefask_map;

#endif   // PrefaskMap_H
