// $Id: Route.cc 1.4 Fri, 18 Jul 1997 15:57:04 -0700 wlee $
// 
//  Copyright (c) 1994 by the University of Southern California
//  and/or the International Business Machines Corporation.
//  All rights reserved.
//
//  Permission to use, copy, modify, and distribute this software and
//  its documentation in source and binary forms for lawful
//  non-commercial purposes and without fee is hereby granted, provided
//  that the above copyright notice appear in all copies and that both
//  the copyright notice and this permission notice appear in supporting
//  documentation, and that any documentation, advertising materials,
//  and other materials related to such distribution and use acknowledge
//  that the software was developed by the University of Southern
//  California, Information Sciences Institute and/or the International
//  Business Machines Corporation.  The name of the USC or IBM may not
//  be used to endorse or promote products derived from this software
//  without specific prior written permission.
//
//  NEITHER THE UNIVERSITY OF SOUTHERN CALIFORNIA NOR INTERNATIONAL
//  BUSINESS MACHINES CORPORATION MAKES ANY REPRESENTATIONS ABOUT
//  THE SUITABILITY OF THIS SOFTWARE FOR ANY PURPOSE.  THIS SOFTWARE IS
//  PROVIDED "AS IS" AND WITHOUT ANY EXPRESS OR IMPLIED WARRANTIES,
//  INCLUDING, WITHOUT LIMITATION, THE IMPLIED WARRANTIES OF
//  MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE, TITLE, AND 
//  NON-INFRINGEMENT.
//
//  IN NO EVENT SHALL USC, IBM, OR ANY OTHER CONTRIBUTOR BE LIABLE FOR ANY
//  SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES, WHETHER IN CONTRACT,
//  TORT, OR OTHER FORM OF ACTION, ARISING OUT OF OR IN CONNECTION WITH,
//  THE USE OR PERFORMANCE OF THIS SOFTWARE.
//
//  Questions concerning this software should be directed to 
//  info-ra@isi.edu.
//
//  Author(s): Cengiz Alaettinoglu <cengiz@isi.edu>

#include "config.hh"
#include <cstdio>
#include "Route.hh"
#include "dbase.hh"
#include "whois.hh"

void Route::define() {
   char buf[100] = "!r";  

   if (nlri.is_dontcare())
      return;

   Prefask_map(nlri.pix).get_address(buf + 2);

   whois.ParseRoute(buf, *this);
}

void Route::define_less_or_equal_specific() {
   char buf[100] = "!r";  

   if (nlri.is_dontcare())
      return;

   Prefask_map(nlri.pix).get_address(buf + 2);
   strcat(buf, ",l");

   whois.ParseRoute(buf, *this);
}

void Route::print() {
   ListNodePix *p;

   cout << "Route:\n";

   if (!nlri.is_dontcare() && !nlri.pix)
      return;

   if (nlri.is_dontcare()) {
      cout << "   NLRI: don't care\n";
   } else {
      cout << "   NLRI: " << Prefask_map(nlri.pix) << "\n";
   }

   cout << "   Origins: ";
   if (origin.is_dontcare()) {
      cout << "don't care\n";
   } else {
      for (p = origin.head(); p; p = origin.next(p->l))
	 cout << AS_map(p->pix) << " ";
      cout << "\n";
   }

   cout << "   Communities: ";
   if (ripecommunity.is_dontcare()) {
      cout << "don't care\n";
   } else {
      for (p = ripecommunity.head(); p; p = ripecommunity.next(p->l))
	 cout << Community_map(p->pix) << " ";
      cout << "\n";
   }

}

